//+------------------------------------------------------------------+
//|                                                         MATF.mq4 |
//|                                      Copyright  2017, Marketeer |
//+------------------------------------------------------------------+
#property copyright "Copyright  2017, Marketeer"
#property link      "https://www.mql5.com/en/users/marketeer"
#property version   "1.0"
#property description "Alternative TimeFrame Moving Average\n"
#property description "Example"

#property strict

#property indicator_chart_window
#property indicator_buffers 1

#property indicator_color1 clrBlue
#property indicator_width1 5

extern int Period = 7;
extern ENUM_TIMEFRAMES TF = PERIOD_CURRENT;
extern ENUM_MA_METHOD MM = MODE_SMA;
extern ENUM_APPLIED_PRICE AP = PRICE_TYPICAL;
extern int Limit = 0;

double Buffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
  SetIndexBuffer(0, Buffer1);
  SetIndexStyle(0, DRAW_LINE);

  IndicatorDigits(_Digits);
  
  return(INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, 
                const datetime& time[],
                const double& open[], const double& high[], const double& low[], const double& close[], 
                const long& tick_volume[], const long& volume[], const int& spread[])
{
  int _limit = Limit == 0 ? rates_total - Period : Limit;
  for(int i = MathMin(rates_total - Period - MathMax(prev_calculated - Period, 1), _limit); i >= 0; i--)
  {
    Buffer1[i] = iMA(_Symbol, TF, Period, 0, MM, AP, iBarShift(_Symbol, TF, time[i]));
  }
  return(rates_total);
}
//+------------------------------------------------------------------+

